Imports System.Windows.Navigation
Imports Microsoft.Devices.Sensors
Imports Microsoft.Phone.Controls
Imports Microsoft.Xna.Framework

Namespace AltitudeAndAzimuth
	Partial Public Class MainPage
		Inherits PhoneApplicationPage

		Private motion As Motion

		Public Sub New()
			InitializeComponent()

			If Motion.IsSupported Then
				motion = New Motion
				motion.TimeBetweenUpdates = TimeSpan.FromMilliseconds(33)
				AddHandler motion.CurrentValueChanged, AddressOf OnMotionCurrentValueChanged
			End If
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
			If motion IsNot Nothing Then
				Try
					motion.Start()
				Catch
				End Try
			End If
			MyBase.OnNavigatedTo(args)
		End Sub

		Protected Overrides Sub OnNavigatedFrom(ByVal args As NavigationEventArgs)
			If motion IsNot Nothing Then
				motion.Stop()
			End If
			MyBase.OnNavigatedFrom(args)
		End Sub

		Private Sub OnMotionCurrentValueChanged(ByVal sender As Object, ByVal args As SensorReadingEventArgs(Of MotionReading))
			Me.Dispatcher.BeginInvoke(Sub()
				Dim matrix As Matrix = args.SensorReading.Attitude.RotationMatrix
				Dim inverseMatrix As Matrix = Matrix.Invert(matrix)
				Dim zAxisTransformed As Vector3 = Vector3.Transform(-Vector3.UnitZ, inverseMatrix)
				xText.Text = zAxisTransformed.X.ToString("F2")
				yText.Text = zAxisTransformed.Y.ToString("F2")
				zText.Text = zAxisTransformed.Z.ToString("F2")
				Dim horzCoord As HorizontalCoordinate = HorizontalCoordinate.FromMotionMatrix(args.SensorReading.Attitude.RotationMatrix)
				altitudeText.Text = horzCoord.Altitude.ToString("F0") & "°"
				azimuthText.Text = horzCoord.Azimuth.ToString("F0") & "°"
				tiltText.Text = horzCoord.Tilt.ToString("F0") & "°"
			End Sub)
		End Sub
	End Class
End Namespace
