Imports System.IO.IsolatedStorage
Imports System.Windows.Navigation
Imports Microsoft.Phone.BackgroundTransfer
Imports Microsoft.Phone.Controls

Namespace BigPicture
	Partial Public Class TransferSettingsPage
		Inherits PhoneApplicationPage

		Public Const Key As String = "TransferPreferences"
		Private settings As IsolatedStorageSettings = IsolatedStorageSettings.ApplicationSettings

		Public Sub New()
			InitializeComponent()
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
			If settings.Contains(Key) Then
				Dim transferPreferences As TransferPreferences = CType(settings(Key), TransferPreferences)
				allowBatteryCheckBox.IsChecked = 0 <> (transferPreferences And TransferPreferences.AllowBattery)
				allowCellularCheckBox.IsChecked = 0 <> (transferPreferences And TransferPreferences.AllowCellular)
			End If

			MyBase.OnNavigatedTo(args)
		End Sub

		Protected Overrides Sub OnNavigatedFrom(ByVal args As NavigationEventArgs)
			Dim transferPreferences As TransferPreferences = TransferPreferences.None

			If allowBatteryCheckBox.IsChecked.Value Then
				transferPreferences = transferPreferences Or TransferPreferences.AllowBattery
			End If

			If allowCellularCheckBox.IsChecked.Value Then
				transferPreferences = transferPreferences Or TransferPreferences.AllowCellular
			End If

			settings(Key) = transferPreferences
			MyBase.OnNavigatedFrom(args)
		End Sub
	End Class
End Namespace
